 member
!_ABCDllMode_  EQUATE(0)
!_ABCLinkMode_ EQUATE(1)

 map
   !Local Procedures, if any, go here
   !API Prototypes
   module('api')
     variantclear(long),long,pascal,proc
     variantinit(long),long,pascal,proc
     memcpy(long,long,long),long,proc,name('_memcpy')
   End

   module('WinApi')
     GetLastError(),LONG,PASCAL
     FormatMessage(ULONG dwFlags,LONG lpSource,ULONG dwMessageId,ULONG LanguageId,*CSTRING lpBuffer,ULONG nSize,ULONG Args),LONG,RAW,PASCAL,NAME('FormatMessageA')
     CreateFile(*CSTRING,ULONG,ULONG,*SECURITY_ATTRIBUTES,ULONG,ULONG,LONG),LONG,RAW,PASCAL,NAME('CreateFileA')
     GetFileSize(LONG,*ULONG),ULONG,PASCAL
     ReadFile(UNSIGNED,ULONG,ULONG,ULONG,ULONG),BOOL,PASCAL,RAW,PROC
     WriteFile(UNSIGNED,ULONG,ULONG,ULONG,ULONG),BOOL,PASCAL,RAW,PROC
     CloseHandle(UNSIGNED),BOOL,PASCAL,RAW,PROC
   End

   Module('advapi32.dll')
     CryptAcquireContext(*LONG hProv,*CSTRING Container,*CSTRING Provider,LONG ProviderType,LONG dwFlags),BYTE,RAW,PASCAL,NAME('CryptAcquireContextA')
     CryptReleaseContext(LONG hProv,LONG dwFlags),BYTE,RAW,PASCAL,PROC
     CryptGetUserKey(LONG hProv, LONG dwKeySpec, *LONG hUserKey),BYTE,RAW,PASCAL
     CryptExportKey(LONG hKey, LONG hExpKey, LONG dwBlobType, LONG dwFlags, LONG pbData, *LONG pdwDataLen),BYTE,RAW,PASCAL
     CryptImportKey(LONG hProv,LONG pbData,LONG dwDataLen,LONG hPubKey,LONG dwFlags,*LONG phKey),BYTE,RAW,PASCAL
     CryptGenKey(LONG hProv, LONG AlgId, LONG dwFlags, *LONG phKey),BYTE,RAW,PASCAL
     CryptDeriveKey(LONG hProv, LONG AlgId, ULONG hHash, ULONG dwFlags, *LONG phKey),BYTE,RAW,PASCAL
     CryptDestroyKey(LONG hKey),BYTE,RAW,PASCAL,proc
     CryptEncrypt(LONG hKey,LONG hHash,BOOL Final,LONG dwflags,LONG pbData,LONG pdwDataLen,LONG dwBufLen),BYTE,RAW,PASCAL
     CryptDecrypt(LONG hKey,LONG hHash,BOOL Final,LONG dwFlags, LONG pbData,LONG pdwDataLen),BYTE,RAW,PASCAL
     CryptCreateHash(LONG hProv, LONG AlgId,LONG hKey,LONG dwFlags,*LONG phHash),BYTE,RAW,PASCAL
     CryptDestroyHash(ULONG),LONG,RAW,PASCAL,proc
     CryptGetHashParam(LONG hHash,LONG dwParam,LONG pbData,*LONG pdwDataLen,LONG dwFlags),BYTE, RAW, PASCAL
     CryptHashData(ULONG hHash,LONG pbData,LONG dwDataLen,LONG dwFlags),BYTE,RAW,PASCAL
     CryptEnumProviders(LONG dwIndex,LONG Reserved,LONG dwFlags,*LONG pdwProviderType,LONG ProviderName,*LONG LenProviderName),BYTE,RAW,PASCAL,NAME('CryptEnumProvidersA')
     CryptGetProvParam(LONG hProv, LONG dwParam, LONG pbData, *LONG dwDataLen, LONG dwFlags),BYTE,RAW,PASCAL
   End
 End



!global data for this module
Return:Benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)

!Includes this class and others
 include('cryptocl.inc')

!-------------------------------------------------------------
!---Start of Cryptcl
!-------------------------------------------------------------
CryptoClType.Init               procedure(byte DebugMode)
!-------------------------------------------------------------
 code
 SELF.DebugMode = DebugMode
 return 0

!-------------------------------------------------------------
CryptoClType.EnumProviders procedure(ProvQType ProvQ)
!-------------------------------------------------------------
idx         ushort(0)
res         byte(return:benign)
Loctype     long
locname     &cstring
loclen      long(100)

 CODE
 loop while CryptEnumProviders(idx,0,0,loctype,0,loclen)
   locname &= NEW(CSTRING(loclen))
   if ~CryptEnumProviders(idx,0,0,loctype,ADDRESS(locname),loclen)
     SELF.HandleError('CryptAcquireContext')
     res = Return:Fatal
     do Procret
   else
     if clip(locname) <> '' then
       ProvQ.Name1 = locname
       ProvQ.Type1 = loctype
       Add(ProvQ)
       idx+=1
     .
   end
 end
 do procret

Procret routine
 return res

!-------------------------------------------------------------
CryptoClType.EnumContainers procedure(ContType ContQ,long context)
!-------------------------------------------------------------
idx         ushort(0)
res         byte(return:benign)
Loctype     long
locname     cstring(100)
loclen      long(100)
DefaultCnt  cstring('<0>')

 CODE
 if ~CryptAcquireContext(SELF.hCryptProv, DefaultCnt, SELF.Provider, SELF.ProviderType, context) then
  SELF.HandleError('CryptAcquireContext')
  res = Return:Fatal
  do procret
 end
 if ~CryptGetProvParam(SELF.hCryptProv,PP_ENUMCONTAINERS,0,loclen,CRYPT_FIRST)
  SELF.HandleError('CryptGetProvParam')
  res = Return:Fatal
  do procret
 end
 setcursor(cursor:wait)
 loop while CryptGetProvParam(SELF.hCryptProv,PP_ENUMCONTAINERS,ADDRESS(locname),loclen,0)
     ContQ.Name2 = locname
     Add(ContQ)
     idx +=1
 end
 setcursor
 
 do procret

Procret routine
 if SELF.hCryptProv then
   CryptReleaseContext(SELF.hCryptProv,0)
 end
 return res

!-------------------------------------------------------------
CryptoClType.CheckForContainer   procedure()
!-------------------------------------------------------------
res         byte(return:benign)
 code

 if ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, 0) THEN
    SELF.HandleError('CryptAcquireContext')
    res = Return:Fatal
 else
   if ~CryptReleaseContext(SELF.hCryptProv,0) THEN
     SELF.HandleError('CryptReleaseContext')
   end
 end
 return res

!-------------------------------------------------------------
CryptoClType.CreateContainer   procedure()
!-------------------------------------------------------------
res         byte(return:benign)
 code
 if ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, CRYPT_NEWKEYSET) THEN
    SELF.HandleError('CryptAcquireContext')
    res = Return:Fatal
 else
   if ~CryptReleaseContext(SELF.hCryptProv,0) THEN
     SELF.HandleError('CryptReleaseContext')
   end
 end
 return res

!-------------------------------------------------------------
CryptoClType.DeleteContainer   procedure()
!-------------------------------------------------------------
res         byte(return:benign)
 code
 if ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, CRYPT_DELETEKEYSET) THEN
    SELF.HandleError('CryptAcquireContext')
    res = Return:Fatal
 else
   if ~CryptReleaseContext(SELF.hCryptProv,0) THEN
     SELF.HandleError('CryptReleaseContext')
   end
 end
 return res

!-------------------------------------------------------------
CryptoClType.GenKeyPairs      procedure()
!-------------------------------------------------------------
res         byte(return:benign)
hExchgKey   long(0)
hSignKey    long(0)
flags       long

 code
 if ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, 0) then
   SELF.HandleError('CryptAcquireContext')
   res = Return:Fatal
   do procret
 end
 flags = BXOR(CRYPT_EXPORTABLE,BSHIFT(SELF.ExchangeKeyLength,16))
 if ~CryptGenKey(SELF.hCryptProv,AT_KEYEXCHANGE,flags,hExchgKey) then
   SELF.HandleError('CryptGenKey - Exchange Key')
   res = Return:Fatal
   do procret
 end
 flags = BXOR(CRYPT_EXPORTABLE,BSHIFT(SELF.SignatureKeyLength,16))
 if ~CryptGenKey(SELF.hCryptProv,AT_SIGNATURE,flags,hSignKey) then
   SELF.HandleError('CryptGenKey - Signature Key')
   res = Return:Fatal
   do procret
 end
 do procret

procret     routine
 if hExchgKey then
   if ~CryptDestroyKey(hExchgKey) THEN
     SELF.HandleError('CryptDestroyKey')
   end
 end
 if hSignKey then
   if ~CryptDestroyKey(hSignKey) THEN
     SELF.HandleError('CryptDestroyKey')
   end
 end
 if SELF.hCryptProv then
   CryptReleaseContext(SELF.hCryptProv,0)
 end
 
 return res


!-------------------------------------------------------------
CryptoClType.GetPublicKeyBlob   procedure(LONG KeyType, LONG Blob, *LONG BlobLen)
!-------------------------------------------------------------
res         byte(return:benign)
hKey        long(0)
LocKey      &String

 code
 IF ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, 0) THEN
    SELF.HandleError('CryptAcquireContext')
    res = Return:Fatal
    do procret
 end
 if ~CryptGetUserKey(SELF.hCryptProv, KeyType, hKey) THEN
   SELF.HandleError('GetUserKey')
   res = Return:Fatal
   do procret
 end
 if ~CryptExportKey(hKey,0,PUBLICKEYBLOB,0,0,BlobLen) Then
   Self.HandleError('CryptExportKey')
   res = Return:Fatal
   do procret
 end
 LocKey &= NEW(STRING(BlobLen))
 if ~CryptExportKey(hKey,0,PUBLICKEYBLOB,0,Blob,BlobLen) Then
   Self.HandleError('CryptExportKey')
   res = Return:Fatal
   do procret
 end
 !Blob = LocKey
 do procret

procret routine
 Dispose(LocKey)
 if hKey then
   if ~CryptDestroyKey(hKey) THEN
     SELF.HandleError('CryptDestroyKey')
   end
 end
 if SELF.hCryptProv then
   if ~CryptReleaseContext(SELF.hCryptProv,0) THEN
     SELF.HandleError('CryptReleaseContext')
   end
 end
 return res


!-------------------------------------------------------------
CryptoClType.CheckForProvider      procedure(string ProviderName)
!-------------------------------------------------------------
dwRet               long(1)
dwIndex             long(0)
dwProviderType      long
dwLen               long(0)
Provider            &cstring
res                 byte(return:notify)

 code
 Loop
   dwRet = CryptEnumProviders(dwIndex,0,0,dwProviderType,0,dwLen)
   Provider &= NEW(cString(dwLen))
   dwRet = CryptEnumProviders(dwIndex,0,0,dwProviderType,ADDRESS(Provider),dwLen)
   if CLIP(Provider) = CLIP(ProviderName) then
    res=return:benign
  .
   Dispose(Provider)
   dwIndex+=1
 While dwRet
   return res

!-------------------------------------------------------------
CryptoClType.SessionEncryptFile      procedure(string infilename,string outfilename,long RcpPubKeyBlob,long RcpPubKeyBlobLen,long AlgID)
!-------------------------------------------------------------
res                 byte(return:benign)
hRcpPubKey          long(0)
hSessionKey         long(0)
SessionKeyBlob      &String
dwKeyLen            long(0)
BytesToRead         ulong(0)
BytesRead           long(0)
BytesWritten        ulong(0)
LocInFileName       cstring(256)
LocOutFileName      cstring(256)
HighSize            ulong
InFileHandle        ulong
OutFileHandle       ulong
FileData            &string
flags               long

SA          group(SECURITY_ATTRIBUTES),PRE()
            end

 code
 if ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, 0) then
   SELF.HandleError('CryptAcquireContext')
   res = Return:Fatal
   do procret
 end

! import the Recipient's public key - used to encrypt the session
 if ~CryptImportKey(SELF.hCryptProv,RcpPubKeyBlob,RcpPubKeyBlobLen,0,0,hRcpPubKey) then
   SELF.HandleError('CryptImportKeyContext')
   res = Return:Fatal
   do procret
 end
 flags = BXOR(CRYPT_EXPORTABLE,BSHIFT(SELF.SessionKeyLength,16))
! create a crypto-random session key
 if ~CryptGenKey(SELF.hCryptProv,AlgId,flags,hSessionKey) then
   SELF.HandleError('CryptGenKey')
   res = Return:Fatal
   do procret
 end

!export & encrypt the session key with the recipient's pub key
 if ~CryptExportKey(hSessionKey,hRcpPubKey,SIMPLEBLOB,0,0,dwKeyLen) then
   SELF.HandleError('CryptExportKey')
   res = Return:Fatal
   do procret
 end
 SessionKeyBlob &=New(STRING(dwKeyLen))
 if ~CryptExportKey(hSessionKey,hRcpPubKey,SIMPLEBLOB,0,ADDRESS(SessionKeyBlob),dwKeyLen) then
   SELF.HandleError('CryptExportKey')
   res = Return:Fatal
   do procret
 end

! Create Output file and insert session key len and then session key
 LocOutFileName = CLIP(outfilename) & '<0>'
 OutFileHandle = CreateFile(LocOutFileName,40000000H,2h,SA,2,80h,0000000h)
 if ~WriteFile(OutFileHandle,ADDRESS(dwKeyLen),Size(dwKeyLen),ADDRESS(BytesWritten),0) then
   SELF.HandleError('WriteFile')
 .

 if ~WriteFile(OutFileHandle,ADDRESS(SessionKeyBlob),dwKeyLen,ADDRESS(BytesWritten),0) then
   SELF.HandleError('WriteFile')
 .

! open infile
 LocInFileName = clip(inFileName) & '<0>'
 InFileHandle = CreateFile(LocInFileName,80000000H,1h,SA,3,80h,0000000h)
 BytesToRead = GetFileSize(InFileHandle,HighSize)
 FileData &= NEW(STRING(BytesToRead))
 if ~ReadFile(InFileHandle,ADDRESS(FileData),BytesToRead,Address(BytesRead),0) then
   SELF.HandleError('ReadFile')
 .
 if ~CryptEncrypt(hSessionKey,0,1,0,ADDRESS(FileData),ADDRESS(BytesToRead),BytesRead)
   SELF.HandleError('CryptEncrypt')
 .

 if ~WriteFile(OutFileHandle,ADDRESS(FileData),BytesToRead,ADDRESS(BytesWritten),0) then
   SELF.HandleError('WriteFile')
 .

 CloseHandle(OutFileHandle)
 CloseHandle(InFileHandle)
 dispose(FileData)
 dispose(SessionKeyBlob)
procret     routine
 if hRcpPubKey then
   if ~CryptDestroyKey(hRcpPubKey) THEN
     SELF.HandleError('CryptDestroyKey')
   end
 end
 if hSessionKey then
   if ~CryptDestroyKey(hSessionKey) THEN
     SELF.HandleError('CryptDestroyKey')
   end
 end
 if SELF.hCryptProv then
   CryptReleaseContext(SELF.hCryptProv,0)
 end

 return res

!-------------------------------------------------------------
CryptoClType.SessionDecryptFile      procedure(string infilename,string outfilename)
!-------------------------------------------------------------
res                 byte(return:benign)
hKeyExchgKey        long(0)
hSessionKey         long(0)
SessionKeyBlob      &String
dwKeyLen            long(0)
BytesToRead         ulong(0)
BytesRead           long(0)
BytesWritten        ulong(0)
LocInFileName       cstring(256)
LocOutFileName      cstring(256)
HighSize            ulong
InFileHandle        ulong
OutFileHandle       ulong
FileData            &string

SA          group(SECURITY_ATTRIBUTES),PRE()
            end

 code
 if ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, 0) then
   SELF.HandleError('CryptAcquireContext')
   res = Return:Fatal
   do procret
 end

! Get our Key Exchange Key - will use this to decrypt session key
 if ~CryptGetUserKey(SELF.hCryptProv, AT_KEYEXCHANGE, hKeyExchgKey) THEN
   SELF.HandleError('GetUserKey')
   res = Return:Fatal
   do procret
 end

! open input (encrypted file)
 LocInFileName = clip(inFileName) & '<0>'
 InFileHandle = CreateFile(LocInFileName,80000000H,1h,SA,3,80h,0000000h)
 BytesToRead = GetFileSize(InFileHandle,HighSize)
 if ~ReadFile(InFileHandle,ADDRESS(dwKeyLen),4,Address(BytesRead),0) then
   SELF.HandleError('ReadFile')
 .
 SessionKeyBlob &= NEW(STRING(dwKeyLen))
 if ~ReadFile(InFileHandle,ADDRESS(SessionKeyBlob),dwKeyLen,Address(BytesRead),0) then
   SELF.HandleError('ReadFile')
 .

! import the Session key
 if ~CryptImportKey(SELF.hCryptProv,ADDRESS(SessionKeyBlob),dwKeyLen,hKeyExchgKey,0,hSessionKey) then
   SELF.HandleError('CryptImportKeyContext')
   res = Return:Fatal
   do procret
 end

 FileData &= NEW(STRING(BytesToRead-4-dwKeyLen))
 if ~ReadFile(InFileHandle,ADDRESS(FileData),Len(FileData),Address(BytesRead),0) then
   SELF.HandleError('ReadFile')
 .

 if ~CryptDecrypt(hSessionKey,0,1,0,ADDRESS(FileData),Address(BytesRead)) then
   SELF.HandleError('CryptDecrypt')
 .
 LocOutFileName = CLIP(outfilename) & '<0>'
 OutFileHandle = CreateFile(LocOutFileName,40000000H,2h,SA,2,80h,0000000h)
  if ~WriteFile(OutFileHandle,ADDRESS(FileData),BytesRead,ADDRESS(BytesWritten),0) then
   SELF.HandleError('WriteFile')
 .

 CloseHandle(OutFileHandle)
 CloseHandle(InFileHandle)
 dispose(FileData)
 dispose(SessionKeyBlob)
 do procret

procret     routine
 if hKeyExchgKey then
   CryptDestroyKey(hKeyExchgKey)
 end
 if hSessionKey then
   CryptDestroyKey(hSessionKey)
 end
 if SELF.hCryptProv then
   CryptReleaseContext(SELF.hCryptProv,0)
 end
 return res

!-------------------------------------------------------------
CryptoClType.PasswordEncryptFile    procedure(string infilename,string outfilename,string Password,long PasswordLen,long AlgID)
!-------------------------------------------------------------
res                 byte(return:benign)
hSessionKey         long
hMyHash             long
BytesToRead         ulong(0)
BytesRead           long(0)
BytesWritten        ulong(0)
BufSize             ulong(0)
LocInFileName       cstring(256)
LocOutFileName      cstring(256)
HighSize            ulong
InFileHandle        ulong
OutFileHandle       ulong
FileData            &string
flags               long

SA                  group(SECURITY_ATTRIBUTES),PRE()
                    end
 code
 if ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, 0) then
   SELF.HandleError('CryptAcquireContext')
   res = Return:Fatal
   do procret
 end
! Create an empty Hash
 if ~CryptCreateHash(SELF.hCryptProv,CALG_SHA,0,0,hMyHash) then
   SELF.HandleError('CryptCreateHash')
   res = Return:Fatal
   do procret
 end
! Hash the supplied Password
 if ~CryptHashData(hMyHash,Address(Password),PasswordLen,0) then
   SELF.HandleError('CryptHashData')
   res = Return:Fatal
   do procret
 end

 flags = BXOR(CRYPT_EXPORTABLE,BSHIFT(SELF.SessionKeyLength,16))

! create a session key derived from the password Hash
 if ~CryptDeriveKey(SELF.hCryptProv, AlgId, hMyHash, flags, hSessionKey) then
   SELF.HandleError('CryptDeriveKey')
   res = Return:Fatal
   do procret
 end
! open infile
 LocInFileName = clip(inFileName) & '<0>'
 InFileHandle = CreateFile(LocInFileName,80000000H,1h,SA,3,80h,0000000h)
 BytesToRead = GetFileSize(InFileHandle,HighSize)
!determine buffer size - the ciphertext is bigger than the plantext with some algorithms
 BufSize = BytesToRead
 if ~CryptEncrypt(hSessionKey,0,1,0,0,ADDRESS(BufSize),BytesToRead)
   SELF.HandleError('CryptEncrypt')
 .
 FileData &= NEW(STRING(BufSize))
 if ~ReadFile(InFileHandle,ADDRESS(FileData),BytesToRead,Address(BytesRead),0) then
   SELF.HandleError('ReadFile')
 .
! encrypt the file
 if ~CryptEncrypt(hSessionKey,0,1,0,ADDRESS(FileData),ADDRESS(BytesRead),BufSize)
   SELF.HandleError('CryptEncrypt')
   res = return:fatal
   do procret
 .
! Create Output file
 LocOutFileName = CLIP(outfilename) & '<0>'
 OutFileHandle = CreateFile(LocOutFileName,40000000H,2h,SA,2,80h,0000000h)
 if ~WriteFile(OutFileHandle,ADDRESS(FileData),BytesRead,ADDRESS(BytesWritten),0) then
   SELF.HandleError('WriteFile')
 .
 do procret

procret     routine
 CloseHandle(OutFileHandle)
 CloseHandle(InFileHandle)
 if FileData then
   dispose(FileData)
 .
 if hMyHash then
   CryptDestroyHash(hMyHash)
 end
 if hSessionKey then
   if ~CryptDestroyKey(hSessionKey) THEN
     SELF.HandleError('CryptDestroyKey')
   end
 end
 if SELF.hCryptProv then
   CryptReleaseContext(SELF.hCryptProv,0)
 end
 return res

!-------------------------------------------------------------
CryptoClType.PasswordDecryptFile      procedure(string infilename,string outfilename,string Password,long PasswordLen,long AlgId)
!-------------------------------------------------------------
res                 byte(return:benign)
hSessionKey         long(0)
hHash               long
BytesToRead         ulong(0)
BytesRead           long(0)
BytesWritten        ulong(0)
LocInFileName       cstring(256)
LocOutFileName      cstring(256)
HighSize            ulong
InFileHandle        ulong
OutFileHandle       ulong
FileData            &string

SA          group(SECURITY_ATTRIBUTES),PRE()
            end

 code
 if ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, 0) then
   SELF.HandleError('CryptAcquireContext')
   res = Return:Fatal
   do procret
 end

! Create an empty Hash
 if ~CryptCreateHash(SELF.hCryptProv,CALG_SHA,0,0,hHash) then
   SELF.HandleError('CryptCreateHash')
   res = Return:Fatal
   do procret
 end

! Hash the supplied Password
 if ~CryptHashData(hHash,ADDRESS(Password),PasswordLen,0) then
   SELF.HandleError('CryptHashData')
   res = Return:Fatal
   do procret
 end

! create a session key derived from the password Hash
 if ~CryptDeriveKey(SELF.hCryptProv,AlgId,hHash,CRYPT_EXPORTABLE,hSessionKey) then
   SELF.HandleError('CryptDeriveKey')
   res = Return:Fatal
   do procret
 end

! open input (encrypted file)
 LocInFileName = clip(inFileName) & '<0>'
 InFileHandle = CreateFile(LocInFileName,80000000H,1h,SA,3,80h,0000000h)
 BytesToRead = GetFileSize(InFileHandle,HighSize)

 FileData &= NEW(STRING(BytesToRead))
 if ~ReadFile(InFileHandle,ADDRESS(FileData),Len(FileData),Address(BytesRead),0) then
   SELF.HandleError('ReadFile')
 .

 if ~CryptDecrypt(hSessionKey,0,1,0,ADDRESS(FileData),Address(BytesRead)) then
   SELF.HandleError('CryptDecrypt')
 .
 LocOutFileName = CLIP(outfilename) & '<0>'
 OutFileHandle = CreateFile(LocOutFileName,40000000H,2h,SA,2,80h,0000000h)
  if ~WriteFile(OutFileHandle,ADDRESS(FileData),BytesRead,ADDRESS(BytesWritten),0) then
   SELF.HandleError('WriteFile')
 .
 do procret

procret     routine
 CloseHandle(OutFileHandle)
 CloseHandle(InFileHandle)
 if FileData then
   dispose(FileData)
 .

 if hHash then
   if ~CryptDestroyHash(hHash) THEN
     SELF.HandleError('CryptDestroyHash')
   end
 end
 if hSessionKey then
   if ~CryptDestroyKey(hSessionKey) THEN
     SELF.HandleError('CryptDestroyKey')
   end
 end
 if SELF.hCryptProv then
   CryptReleaseContext(SELF.hCryptProv,0)
 end
 return res


!-------------------------------------------------------------
CryptoClType.HashPassword     procedure(string password, long PasswordLen, *string rethash, *long hashlen, long AlgId)
!-------------------------------------------------------------
res                 byte(return:benign)
hHash               long
HashStr             &string
HashArr             BYTE,DIM(4),over(hashlen)
hashlensize         long(4)

 code
  if ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, 0) then
   SELF.HandleError('CryptAcquireContext')
   res = Return:Fatal
   do procret
 end
! Create an empty Hash
 if ~CryptCreateHash(SELF.hCryptProv,AlgId,0,0,hHash) then
   SELF.HandleError('CryptCreateHash')
   res = Return:Fatal
   do procret
 end

! Hash the supplied Password
 if ~CryptHashData(hHash,ADDRESS(Password),PasswordLen,0) then
   SELF.HandleError('CryptHashData')
   res = Return:Fatal
   do procret
 end

 if ~CryptGetHashParam(hHash,HP_HASHSIZE,ADDRESS(HashArr[1]),Hashlensize,0) then
   SELF.HandleError('CryptGetHashParam')
   res = Return:Fatal
   do procret
 end
 HashStr &= NEW(STRING(HashLen))
 if ~CryptGetHashParam(hHash,HP_HASHVAL,ADDRESS(HashStr),Hashlen,0) then
   SELF.HandleError('CryptGetHashParam')
   res = Return:Fatal
   do procret
 end
 rethash = HashStr
 do procret

procret     routine
 dispose(hashstr)
 if hHash then
   if ~CryptDestroyHash(hHash) THEN
     SELF.HandleError('CryptDestroyHash')
   end
 end
 if SELF.hCryptProv then
   CryptReleaseContext(SELF.hCryptProv,0)
 end
 return res

!-------------------------------------------------------------
CryptoClType.CheckPasswordHash     procedure(string password, long PasswordLen, string inhash, long inhashlen, long AlgId)
!-------------------------------------------------------------
res                 byte(return:benign)
hHash               long
hashlen             long
HashArr             BYTE,DIM(4),over(hashlen)
hashlensize         long(4)
HashStr             &string
 code
  if ~CryptAcquireContext(SELF.hCryptProv, SELF.Container, SELF.Provider, SELF.ProviderType, 0) then
   SELF.HandleError('CryptAcquireContext')
   res = Return:Fatal
   do procret
 end
! Create an empty Hash
 if ~CryptCreateHash(SELF.hCryptProv,AlgId,0,0,hHash) then
   SELF.HandleError('CryptCreateHash')
   res = Return:Fatal
   do procret
 end
! Hash the supplied Password
 if ~CryptHashData(hHash,ADDRESS(Password),PasswordLen,0) then
   SELF.HandleError('CryptHashData')
   res = Return:Fatal
   do procret
 end
 if ~CryptGetHashParam(hHash,HP_HASHSIZE,ADDRESS(HashArr[1]),Hashlensize,0) then
   SELF.HandleError('CryptGetHashParam')
   res = Return:Fatal
   do procret
 end
 if Hashlen <> inhashlen then
   res = return:notify
   do procret
 .

 HashStr &= NEW(STRING(HashLen))

 if ~CryptGetHashParam(hHash,HP_HASHVAL,ADDRESS(HashStr),Hashlen,0) then
   SELF.HandleError('CryptGetHashParam')
   res = Return:Fatal
   do procret
 end

 if HashStr <> inhash[1:inhashlen] then
   res = return:notify
   do procret
 .
 do procret
procret     routine
 dispose(hashstr)
 if hHash then
   if ~CryptDestroyHash(hHash) THEN
     SELF.HandleError('CryptDestroyHash')
   end
 end
 if SELF.hCryptProv then
   CryptReleaseContext(SELF.hCryptProv,0)
 end
 return res


!-------------------------------------------------------------
CryptoClType.HandleError      procedure(<string Method>)
!-------------------------------------------------------------
 code
    SELF.ErrorCode = GetLastError()
    IF ~FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM + FORMAT_MESSAGE_IGNORE_INSERTS,0,SELF.ErrorCode,0,SELF.ErrorDesc,256,0) then
      SELF.ErrorDesc = 'Format Message failed'
    end

 if SELF.DebugMode then
   Message('Error Code: ' & SELF.ErrorCode & '|Error Desc: ' & SELF.ErrorDesc, 'CryptoCl Error - ' & Method, ICON:Exclamation, BUTTON:OK)
 end

