!ABCIncludeFile

OMIT('_EndOfInclude_',_CryptoClPresent_)
_CryptoClPresent_   EQUATE(1)

! Equates for CryptoAPI

! Algorithm classes
ALG_CLASS_ANY                   EQUATE (0)
ALG_CLASS_SIGNATURE             EQUATE (8192)
ALG_CLASS_MSG_ENCRYPT           EQUATE (16384)
ALG_CLASS_DATA_ENCRYPT          EQUATE (24576)
ALG_CLASS_HASH                  EQUATE (32768)
ALG_CLASS_KEY_EXCHANGE          EQUATE (40960)

! Algorithm types
ALG_TYPE_ANY                    EQUATE (0)
ALG_TYPE_DSS                    EQUATE (512)
ALG_TYPE_RSA                    EQUATE (1024)
ALG_TYPE_BLOCK                  EQUATE (1536)
ALG_TYPE_STREAM                 EQUATE (2048)
ALG_TYPE_DH                     EQUATE (2560)
ALG_TYPE_SECURECHANNEL          EQUATE (3072)

! Some RSA sub-ids
ALG_SID_RSA_ANY                 EQUATE(0)
ALG_SID_RSA_PKCS                EQUATE(1)
ALG_SID_RSA_MSATWORK            EQUATE(2)
ALG_SID_RSA_ENTRUST             EQUATE(3)
ALG_SID_RSA_PGP                 EQUATE(4)

! RC2 sub-ids
ALG_SID_RC2                     EQUATE (2)

! Stream cipher sub-ids
ALG_SID_RC4                     EQUATE (1)
ALG_SID_SEAL                    EQUATE (2)

! Hash sub ids
ALG_SID_MD2                     EQUATE (1)
ALG_SID_MD4                     EQUATE (2)
ALG_SID_MD5                     EQUATE (3)
ALG_SID_SHA                     EQUATE (4)
ALG_SID_SHA1                    EQUATE (4)
ALG_SID_MAC                     EQUATE (5)
ALG_SID_RIPEMD                  EQUATE (6)
ALG_SID_RIPEMD160               EQUATE (7)
ALG_SID_SSL3SHAMD5              EQUATE (8)
ALG_SID_HMAC                    EQUATE (9)

! DSS sub ids
ALG_SID_DSS_ANY                 EQUATE(0)
ALG_SID_DSS_PKCS                EQUATE(1)
ALG_SID_DSS_DMS                 EQUATE(2)
! DES sub_ids
ALG_SID_DES                     EQUATE(1)
ALG_SID_3DES                    EQUATE(3)
ALG_SID_DESX                    EQUATE(4)
! Block cipher sub ids
ALG_SID_IDEA                    EQUATE(5)
ALG_SID_CAST                    EQUATE(6)
ALG_SID_SAFERSK64               EQUATE(7)
ALG_SID_SAFERSK128              EQUATE(8)
ALG_SID_3DES_112                EQUATE(9)
ALG_SID_CYLINK_MEK              EQUATE(12)
ALG_SID_RC5                     EQUATE(13)


! algorithm identifier definitions
CALG_MD2                        EQUATE (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_MD2)
CALG_MD4                        EQUATE (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_MD4)
CALG_MD5                        EQUATE (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_MD5)
CALG_RC2                        EQUATE (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_RC2)
CALG_RC4                        EQUATE (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_STREAM + ALG_SID_RC4)
CALG_SHA                        EQUATE (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_SHA)
CALG_SHA1                       EQUATE (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_SHA1)
CALG_MAC                        EQUATE (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_MAC)
CALG_RSA_SIGN                   EQUATE (ALG_CLASS_SIGNATURE + ALG_TYPE_RSA + ALG_SID_RSA_ANY)
CALG_DSS_SIGN                   EQUATE (ALG_CLASS_SIGNATURE + ALG_TYPE_DSS + ALG_SID_DSS_ANY)
CALG_RSA_KEYX                   EQUATE (ALG_CLASS_KEY_EXCHANGE + ALG_TYPE_RSA + ALG_SID_RSA_ANY)
CALG_DES                        EQUATE (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_DES)
CALG_3DES_112                   EQUATE (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_3DES_112)
CALG_3DES                       EQUATE (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_3DES)
CALG_RC5                        EQUATE (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_RC5)
CALG_HMAC                       EQUATE (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_HMAC)




! dwFlags definitions for CryptAcquireContext
CRYPT_VERIFYCONTEXT             EQUATE (0F0000000h)
CRYPT_NEWKEYSET                 EQUATE (000000008h)
CRYPT_DELETEKEYSET              EQUATE (000000010h)
CRYPT_MACHINE_KEYSET            EQUATE (000000020h)

! Provider Types
PROV_RSA_FULL                   EQUATE  (1)
PROV_RSA_SIG                    EQUATE  (2)
PROV_DSS                        EQUATE  (3)
PROV_FORTEZZA                   EQUATE  (4)
PROV_MS_EXCHANGE                EQUATE  (5)
PROV_SSL                        EQUATE  (6)
PROV_RSA_SCHANNEL               EQUATE (12)
PROV_DSS_DH                     EQUATE (13)
PROV_EC_ECDSA_SIG               EQUATE (14)
PROV_EC_ECNRA_SIG               EQUATE (15)
PROV_EC_ECDSA_FULL              EQUATE (16)
PROV_EC_ECNRA_FULL              EQUATE (17)
PROV_SPYRUS_LYNKS               EQUATE (20)

! Provider public names
MS_DEF_PROV                     EQUATE ('Microsoft Base Cryptographic Provider v1.0')
MS_ENHANCED_PROV                EQUATE ('Microsoft Enhanced Cryptographic Provider v1.0')
MS_STRONG_PROV                  EQUATE ('Microsoft Strong Cryptographic Provider')
MS_DEF_RSA_SIG_PROV             EQUATE ('Microsoft RSA Signature Cryptographic Provider')
MS_DEF_RSA_SCHANNEL_PROV        EQUATE ('Microsoft Base RSA SChannel Cryptographic Provider')
MS_ENHANCED_RSA_SCHANNEL_PROV   EQUATE ('Microsoft Enhanced RSA SChannel Cryptographic Provider')
MS_DEF_DSS_PROV                 EQUATE ('Microsoft Base DSS Cryptographic Provider')
MS_DEF_DSS_DH_PROV              EQUATE ('Microsoft Base DSS and Diffie-Hellman Cryptographic Provider')


! dwFlag definitions for CryptGenKey
CRYPT_EXPORTABLE                EQUATE (000000001h)
CRYPT_USER_PROTECTED            EQUATE (000000002h)
CRYPT_CREATE_SALT               EQUATE (000000004h)
CRYPT_UPDATE_KEY                EQUATE (000000008h)
CRYPT_NO_SALT                   EQUATE (000000010h)
CRYPT_PREGEN                    EQUATE (000000040h)
CRYPT_RECIPIENT                 EQUATE (000000010h)
CRYPT_INITIATOR                 EQUATE (000000040h)
CRYPT_ONLINE                    EQUATE (000000080h)
CRYPT_SF                        EQUATE (000000100h)
CRYPT_CREATE_IV                 EQUATE (000000200h)
CRYPT_KEK                       EQUATE (000000400h)
CRYPT_DATA_KEY                  EQUATE (000000800h)

! dwFlags definitions for CryptDeriveKey
CRYPT_SERVER                    EQUATE (000000400h)
KEY_LENGTH_MASK                 EQUATE (0FFFF0000h)

! dwFlag definitions for CryptExportKey
CRYPT_Y_ONLY                    EQUATE (000000001h)
CRYPT_SSL2_SLUMMING             EQUATE (000000002h)

! dwFlags definitions for CryptHashSessionKey
CRYPT_LITTLE_ENDIAN             EQUATE (000000001h)

! dwFlag definitions for CryptSetProviderEx and CryptGetDefaultProvider
CRYPT_MACHINE_DEFAULT           EQUATE (000000001h)
CRYPT_USER_DEFAULT              EQUATE (000000002h)
CRYPT_DELETE_DEFAULT            EQUATE (000000004h)

! exported key blob definitions
SIMPLEBLOB                      EQUATE (01h)
PUBLICKEYBLOB                   EQUATE (06h)
PRIVATEKEYBLOB                  EQUATE (07h)
PLAINTEXTKEYBLOB                EQUATE (08h)
AT_KEYEXCHANGE                  EQUATE (1)
AT_SIGNATURE                    EQUATE (2)
CRYPT_USERDATA                  EQUATE (1)

! CryptGetProvParam
!
PP_ENUMALGS                     EQUATE(1)
PP_ENUMCONTAINERS               EQUATE(2)
PP_IMPTYPE                      EQUATE(3)
PP_NAME                         EQUATE(4)
PP_VERSION                      EQUATE(5)
PP_CONTAINER                    EQUATE(6)
PP_CHANGE_PASSWORD              EQUATE(7)
PP_KEYSET_SEC_DESCR             EQUATE(8)               ! get/set security descriptor of keyset
PP_CERTCHAIN                    EQUATE(9)               ! for retrieving certificates from tokens
PP_KEY_TYPE_SUBTYPE             EQUATE(10)
PP_PROVTYPE                     EQUATE(16)
PP_KEYSTORAGE                   EQUATE(17)
PP_APPLI_CERT                   EQUATE(18)
PP_SYM_KEYSIZE                  EQUATE(19)
PP_SESSION_KEYSIZE              EQUATE(20)
PP_UI_PROMPT                    EQUATE(21)
PP_ENUMALGS_EX                  EQUATE(22)
CRYPT_FIRST                     EQUATE(1)
CRYPT_NEXT                      EQUATE(2)
CRYPT_IMPL_HARDWARE             EQUATE(1)
CRYPT_IMPL_SOFTWARE             EQUATE(2)
CRYPT_IMPL_MIXED                EQUATE(3)
CRYPT_IMPL_UNKNOWN              EQUATE(4)
! key storage flags
CRYPT_SEC_DESCR                 EQUATE (000000001h)
CRYPT_PSTORE                    EQUATE (000000002h)
CRYPT_UI_PROMPT                 EQUATE (000000004h)

! CryptSetProvParam
PP_CLIENT_HWND                  EQUATE(1)
PP_CONTEXT_INFO                 EQUATE(11)
PP_KEYEXCHANGE_KEYSIZE          EQUATE(12)
PP_SIGNATURE_KEYSIZE            EQUATE(13)
PP_KEYEXCHANGE_ALG              EQUATE(14)
PP_SIGNATURE_ALG                EQUATE(15)
PP_DELETEKEY                    EQUATE(24)


HP_ALGID                        EQUATE  (1h)   ! Hash algorithm
HP_HASHVAL                      EQUATE  (2h)   ! Hash value
HP_HASHSIZE                     EQUATE  (4h)   ! Hash value size
HP_HMAC_INFO                    EQUATE  (5h)   ! info for creating an HMAC

! Error codes
NTE_BAD_KEYSET                  EQUATE (80090016h)

FORMAT_MESSAGE_ALLOCATE_BUFFER EQUATE(00000100h)
FORMAT_MESSAGE_IGNORE_INSERTS  EQUATE(00000200h)
FORMAT_MESSAGE_FROM_STRING     EQUATE(00000400h)
FORMAT_MESSAGE_FROM_HMODULE    EQUATE(00000800h)
FORMAT_MESSAGE_FROM_SYSTEM     EQUATE(00001000h)
FORMAT_MESSAGE_ARGUMENT_ARRAY  EQUATE(00002000h)
FORMAT_MESSAGE_MAX_WIDTH_MASK  EQUATE(000000FFh)

SECURITY_ATTRIBUTES GROUP,TYPE
nLength               ULONG
lpSecurityDescriptor  ULONG
bInheritHandle        SIGNED
                    END

ProvQType           Queue,Type
Name1                  STRING(100)
Type1                  Long
                    .

ContQType           Queue,Type
Name2                  STRING(100)
                    .

CryptoClType Class,type,module('cryptocl.clw'),LINK('cryptocl.clw',_ABCLinkMode_),DLL(_ABCDllMode_)

!Member Data
DebugMode           byte(0),private
hCryptProv          long(0),private
Container           cstring(100)
Provider            cstring(100)
ProviderType        long
ErrorDesc           cstring(256)
ErrorCode           long
ExchangeKeyLength   long
SignatureKeyLength  long
SessionKeyLength    long
AlgId               long

!Methods - all return 0 for success if they return anything
init                procedure(byte pDebug=0),byte,proc
CheckForProvider    procedure(string ProvName),byte,proc
CheckForContainer   procedure(),byte,proc
CreateContainer     procedure(),byte,proc
DeleteContainer     procedure(),byte,proc
GenKeyPairs         procedure(),byte,proc
GetPublicKeyBlob    procedure(long KeyType, long Blob, *long BlobLen),byte,proc
SessionEncryptFile  procedure(string infilename,string outfilename,long RcpPubKeyBlob,long RcpPubKeyBlobLen,long AlgID),byte,proc
SessionDecryptFile  procedure(string infilename,string outfilename),byte,proc
PasswordEncryptFile procedure(string infile,string outfile,string Password,long PasswordLen,long AlgId),byte,proc
PasswordDecryptFile procedure(string infilename,string outfilename,string Password,long PasswordLen,long AlgId),byte,proc
HashPassword        procedure(string password, long PasswordLen, *string hash, *long HashLen, long AlgId),byte,proc
CheckPasswordHash   procedure(string password, long PasswordLen, string inhash, long inHashLen, long AlgId),byte,proc
HandleError         procedure(<STRING Method>)
EnumProviders       procedure(*ProvQType ProvQ),byte,proc
EnumContainers      procedure(*ContQType ContQ, LONG context),byte,proc
End


!_EndOfInclude_
